#ifndef _SENSORS_h
#define _SENSORS_h
#if defined(ARDUINO) && ARDUINO >= 100
#include "arduino.h"
#else
#include "WProgram.h"
#endif

#include "HPController.h"
#include "math.h"
#include <Wire.h>

//#define PCF8591 (0x90 >> 1) // I2C bus address
#define PCF8591 (0x92 >> 1) // I2C bus address with A0 HIGH
#define ADC0 0x00 // control bytes for reading individual ADCs
#define ADC1 0x01
#define ADC2 0x02
#define ADC3 0x03

//Analogue sensors
#define TEMP_COMPRESSOR sensors.adcSensor[0]
#define TEMP_EVAPORATOR sensors.adcSensor[1]
#define TEMP_EXTERNAL sensors.adcSensor[2]
#define TEMP_EVAPMID sensors.adcSensor[3]
#define TEMP_WATER sensors.adcSensor[4]

class Sensors
{
public:
	int adcSensor[5];

	// Read ntc temperature sensors
	void readTemperatureSensors();
	
private:
	byte sample = 0;
	int waterTemperature[10] = { 0,0,0,0,0,0,0,0,0,0 };
	const char * sensorName[5] = { "Compressor", "Evaporator", "External", "Evap. Mid", "Actual"};

	//Convert raw adc value to temperature in C
	int convertToTemperature(int rawADC, double convertFactor);
	int in_range(unsigned int x, int lower, int upper);
	int readSingle(int adc);
};

extern Sensors sensors;
#endif
